"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.MemoryAdapter = void 0;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var MemoryAdapter =
/*#__PURE__*/
function () {
  function MemoryAdapter() {
    _classCallCheck(this, MemoryAdapter);

    if (!this.tableData) {
      this.tableData = {};
    }
  }

  _createClass(MemoryAdapter, [{
    key: "get",
    value: function get(key) {
      return this.tableData[key];
    }
  }, {
    key: "put",
    value: function put(key, val) {
      this.tableData[key] = val;
    }
  }, {
    key: "clear",
    value: function clear() {
      this.tableData = {};
    }
  }]);

  return MemoryAdapter;
}();

exports.MemoryAdapter = MemoryAdapter;

var _default = new MemoryAdapter();

exports["default"] = _default;