"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ConditionItem = exports.ConditionParas = void 0;

// var ConditionParas = ConditionParas || {};
// (function() {
var ConditionParas = function ConditionParas() {
  var Return = {
    condParas: [],
    condFormKey: "",
    setCondFormKey: function setCondFormKey(condFormKey) {
      this.condFormKey = condFormKey;
    },
    getCondFormKey: function getCondFormKey() {
      return this.condFormKey;
    },
    add: function add(condItem) {
      this.condParas.push(condItem);
    },
    get: function get(i) {
      return this.condParas[i];
    },
    size: function size() {
      return this.condParas.length;
    },
    getCondParas: function getCondParas() {
      return {
        condParas_items: this.condParas
      };
    },
    clear: function clear() {
      this.condParas.length = 0;
    }
  };
  return Return;
};

exports.ConditionParas = ConditionParas;

var ConditionItem = function ConditionItem() {
  var Return = {
    /** 查询字段组建的key */
    key: "",

    /** 查询字段类型 */
    type: -1,

    /** 查询条件 */
    condSign: -1,

    /** 条件组标识 */
    group: "",

    /** 条件组头标志 */
    groupHead: false,

    /** 条件组尾标志 */
    groupTail: false,

    /** 查询的目标表 */
    targetTableKey: "",

    /** 条件关联的数据表标识 */
    tableKey: "",

    /** 条件关联的数据列标识 */
    columnKey: "",

    /** 查询的值 */
    value: "",
    setKey: function setKey(key) {
      this.key = key;
    },
    getKey: function getKey() {
      return this.key;
    },
    setType: function setType(type) {
      this.type = type;
    },
    getType: function getType() {
      return this.type;
    },
    setCondSign: function setCondSign(condSign) {
      this.condSign = condSign;
    },
    getCondSign: function getCondSign() {
      return this.condSign;
    },
    setGroup: function setGroup(group) {
      this.group = group;
    },
    getGroup: function getGroup() {
      return this.group;
    },
    setGroupHead: function setGroupHead(groupHead) {
      this.groupHead = groupHead;
    },
    isGroupHead: function isGroupHead() {
      return this.groupHead;
    },
    setGroupTail: function setGroupTail(groupTail) {
      this.groupTail = groupTail;
    },
    isGroupTail: function isGroupTail() {
      return this.groupTail;
    },
    setTargetTableKey: function setTargetTableKey(targetTableKey) {
      this.targetTableKey = targetTableKey;
    },
    getTargetTableKey: function getTargetTableKey() {
      return this.targetTableKey;
    },
    setTableKey: function setTableKey(tableKey) {
      this.tableKey = tableKey;
    },
    getTableKey: function getTableKey() {
      return this.tableKey;
    },
    setColumnKey: function setColumnKey(columnKey) {
      this.columnKey = columnKey;
    },
    getColumnKey: function getColumnKey() {
      return this.columnKey;
    },
    setValue: function setValue(value) {
      this.value = value;
    },
    getValue: function getValue() {
      return this.value;
    }
  };
  return Return;
}; // })();


exports.ConditionItem = ConditionItem;