"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _control = _interopRequireDefault(require("./control"));

var _YIUIBase = require("../../YIUI-base");

require("../../YIUI-common");

var _YIUISvr = _interopRequireDefault(require("../../YIUI-svr"));

require("../../YIUI-parser");

var _controlUtil = require("./controlUtil");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var BPMGraph = _YIUIBase.YIUI.extend(_control["default"], {
  init: function init(options) {
    this.base(options);
  },
  calculateDisplayValue: function () {
    var _calculateDisplayValue = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee(v) {
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              this.text = v || this.caption;
              return _context.abrupt("return", this.text);

            case 2:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    function calculateDisplayValue(_x) {
      return _calculateDisplayValue.apply(this, arguments);
    }

    return calculateDisplayValue;
  }()
});

_YIUIBase.YIUI.reg('bpmgraph', BPMGraph);

(0, _controlUtil.regControlType)(239, 'bpmgraph');
var _default = BPMGraph;
exports["default"] = _default;