"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _control = _interopRequireDefault(require("./control"));

var _controlUtil = require("./controlUtil");

var _YIUIBase = require("../../YIUI-base");

require("../../YIUI-common");

var _YIUISvr = _interopRequireDefault(require("../../YIUI-svr"));

require("../../YIUI-parser");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var Image = _YIUIBase.YIUI.extend(_control["default"], {
  calculateDisplayValue: function () {
    var _calculateDisplayValue = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee(v) {
      var form, formKey, sourceType, text;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              form = _YIUIBase.YIUI.FormStack.getForm(this.ofFormID);
              formKey = form.formKey;
              sourceType = this.getMetaObj().sourceType;

              if (!v) {
                _context.next = 10;
                break;
              }

              if (!(sourceType === _YIUIBase.YIUI.IMAGE_SOURCETYPE.DATA)) {
                _context.next = 9;
                break;
              }

              text = "".concat(_YIUISvr["default"].SvrMgr.AttachURL, "?path=").concat(encodeURIComponent(v), "&formKey=").concat(formKey, "&service=DownloadImage&mode=2");
              return _context.abrupt("return", text);

            case 9:
              return _context.abrupt("return", "".concat(_YIUISvr["default"].SvrMgr.AttachURL, "/../Resource/").concat(this.getMetaObj().image));

            case 10:
              return _context.abrupt("return", '');

            case 11:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    function calculateDisplayValue(_x) {
      return _calculateDisplayValue.apply(this, arguments);
    }

    return calculateDisplayValue;
  }()
});

_YIUIBase.YIUI.reg('image', Image);

(0, _controlUtil.regControlType)(_YIUIBase.YIUI.CONTROLTYPE.IMAGE, 'image');
var _default = Image;
exports["default"] = _default;