"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _yesCommon = require("yes-common");

var _YIUIBase = require("../../YIUI-base");

require("../../YIUI-common");

require("../../YIUI-svr");

require("../../YIUI-parser");

var _control = _interopRequireDefault(require("./control"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

// import { regControlType } from './controlUtil';
_YIUIBase.YIUI.StackContainer = _YIUIBase.YIUI.extend(_control["default"], {
  /** 如果items未定义type，默认为component */
  defaultType: 'component',

  /** 容器中子控件布局方式 */
  layout: 'auto',
  // overflowX: 'visible',
  // overflowY: 'visible',
  // backImage: '',
  // backImagePosition: '',
  // isBackImageRepeatX: false,
  // isBackImageRepeatY: false,
  // padding: 1,
  init: function init(options) {
    this.base(options);
    this.state = this.state.merge({
      formKey: '',
      oid: ''
    });
  },
  build: function build(form) {// var rootpanel = form.getRootPanel();
    // this.add(rootpanel);
    // form.setContainer(this);
  },
  open: function open(formKey, oid) {
    this.formID = _YIUIBase.YIUI.Form_allocFormID();
    var state = this.state.merge({
      formKey: formKey,
      oid: oid,
      formID: this.formID
    });
    this.changeState(state);
  },
  getActivePane: function getActivePane() {
    return _YIUIBase.YIUI.FormStack.getForm(this.formID);
  }
});

_YIUIBase.YIUI.reg('stackcontainer', _YIUIBase.YIUI.StackContainer);

var _default = _YIUIBase.YIUI.StackContainer;
exports["default"] = _default;