"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _control = _interopRequireDefault(require("./control"));

var _YIUIBase = require("../../YIUI-base");

require("../../YIUI-common");

require("../../YIUI-svr");

require("../../YIUI-parser");

var _controlUtil = require("./controlUtil");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/*
 * @Author: gmf
 * @Date:   2016-03-18 10:53:01
 * @Last Modified by:   gmf
 * @Last Modified time: 2016-06-23 09:48:39
 */
var TextArea = _YIUIBase.YIUI.extend(_control["default"], {
  handler: _YIUIBase.YIUI.TextAreaHandler,

  /**
   * Number。
   * 允许输入的最大长度。
   */
  maxLength: Number.MAX_VALUE,
  getText: function getText() {
    return this.value;
  }
});

_YIUIBase.YIUI.reg('textarea', TextArea);

_YIUIBase.YIUI.reg('richeditor', TextArea);

(0, _controlUtil.regControlType)(_YIUIBase.YIUI.CONTROLTYPE.TEXTAREA, 'textarea');
(0, _controlUtil.regControlType)(_YIUIBase.YIUI.CONTROLTYPE.RICHEDITOR, 'richeditor');
var _default = TextArea;
exports["default"] = _default;