"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _YIUIBase = require("../YIUI-base");

require("../YIUI-common");

require("../YIUI-parser");

require("../YIUI-svr");

var _yesCommon = require("yes-common");

require("../uiprocess");

require("../abstractuiprocess");

require("../yes-ui");

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

//  var YIUI = YIUI || {};
// (function () {
var _default = _YIUIBase.YIUI.UICalcProcess = _YIUIBase.YIUI.extend(_YIUIBase.YIUI.AbstractUIProcess, {
  init: function init(form) {
    this.base(form);
  },
  isInAllCalculating: function isInAllCalculating() {
    return this.calcAlling;
  },
  calcAlling: false,
  calcAll: function () {
    var _calcAll = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee(commitValue) {
      var items;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              this.calcAlling = true;
              items = this.form.dependency.calcTree.items;
              _context.t0 = this.form.operationState;
              _context.next = _context.t0 === _YIUIBase.YIUI.Form_OperationState.New ? 5 : _context.t0 === _YIUIBase.YIUI.Form_OperationState.Edit ? 8 : _context.t0 === _YIUIBase.YIUI.Form_OperationState.Default ? 8 : 11;
              break;

            case 5:
              _context.next = 7;
              return this.calcAllItems(true, items, commitValue);

            case 7:
              return _context.abrupt("break", 12);

            case 8:
              _context.next = 10;
              return this.calcAllItems(false, items, commitValue);

            case 10:
              return _context.abrupt("break", 12);

            case 11:
              return _context.abrupt("break", 12);

            case 12:
              // 计算所有表格的汇总
              // var gm = this.form.getGridInfoMap();
              // for (var i = 0, grid, size = gm.length; i < size; i++) {
              //     grid = this.form.getComponent(gm[i].key);
              //     YIUI.GridSumUtil.evalSum(this.form, grid);
              // }
              this.form.removeSysExpVals("IgnoreKeys");
              this.calcAlling = false;

            case 14:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    function calcAll(_x) {
      return _calcAll.apply(this, arguments);
    }

    return calcAll;
  }(),
  calcAllItems: function () {
    var _calcAllItems = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee2(calcAll, items, commitValue) {
      var i, exp, component;
      return regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              i = 0;

            case 1:
              if (!(exp = items[i])) {
                _context2.next = 23;
                break;
              }

              component = this.form.getComponent(exp.source);

              if (!(!component || component.isSubDetail)) {
                _context2.next = 5;
                break;
              }

              return _context2.abrupt("continue", 20);

            case 5:
              _context2.t0 = exp.objectType;
              _context2.next = _context2.t0 === _YIUIBase.YIUI.ExprItem_Type.Item ? 8 : _context2.t0 === _YIUIBase.YIUI.ExprItem_Type.Set ? 11 : 20;
              break;

            case 8:
              _context2.next = 10;
              return this.calcHeadItem(component, exp, this.newContext(this.form, -1, -1), calcAll);

            case 10:
              return _context2.abrupt("break", 20);

            case 11:
              _context2.t1 = component.type;
              _context2.next = _context2.t1 === _YIUIBase.YIUI.CONTROLTYPE.GRID ? 14 : _context2.t1 === _YIUIBase.YIUI.CONTROLTYPE.LISTVIEW ? 17 : 20;
              break;

            case 14:
              _context2.next = 16;
              return this.calcGrid(component, this.newContext(this.form, -1, -1), this.initTree(exp), calcAll, commitValue);

            case 16:
              return _context2.abrupt("break", 20);

            case 17:
              _context2.next = 19;
              return this.calcListView(component, this.newContext(this.form, -1, -1), this.initTree(exp), calcAll);

            case 19:
              return _context2.abrupt("break", 20);

            case 20:
              i++;
              _context2.next = 1;
              break;

            case 23:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2, this);
    }));

    function calcAllItems(_x2, _x3, _x4) {
      return _calcAllItems.apply(this, arguments);
    }

    return calcAllItems;
  }(),
  calcHeadItem: function () {
    var _calcHeadItem = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee3(component, item, context, calcAll) {
      var cellLocation, metaCell, rowData, pos, i, length, result, _result, _result2;

      return regeneratorRuntime.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              if (!(!item.defaultValue && !item.formula || !item.target)) {
                _context3.next = 2;
                break;
              }

              return _context3.abrupt("return");

            case 2:
              if (!(component.type == _YIUIBase.YIUI.CONTROLTYPE.GRID)) {
                _context3.next = 31;
                break;
              }

              cellLocation = this.form.getCellLocation(item.target);
              metaCell = component.getMetaCellByKey(item.target);
              rowData = component.getRowDataAt(cellLocation.row);

              if (rowData) {
                _context3.next = 8;
                break;
              }

              return _context3.abrupt("return");

            case 8:
              // if (!this.needCalc_Cell(metaCell, calcAll))
              //     return;
              pos = item.pos;

              if (!pos.columnExpand) {
                _context3.next = 23;
                break;
              }

              i = 0, length = pos.indexes.length;

            case 11:
              if (!(i < length)) {
                _context3.next = 21;
                break;
              }

              if (!this.needCalc_Cell(component, cellLocation.row, pos.indexes[i], metaCell)) {
                _context3.next = 18;
                break;
              }

              context.rowIndex = cellLocation.row;
              _context3.next = 16;
              return this.calcFormulaValue(item, context);

            case 16:
              result = _context3.sent;
              component.setValueAt(cellLocation.row, pos.indexes[i], result, true, false);

            case 18:
              i++;
              _context3.next = 11;
              break;

            case 21:
              _context3.next = 29;
              break;

            case 23:
              if (!this.needCalc_Cell(component, cellLocation.row, pos.index, rowData.data[pos.index], metaCell)) {
                _context3.next = 29;
                break;
              }

              context.rowIndex = cellLocation.row;
              _context3.next = 27;
              return this.calcFormulaValue(item, context);

            case 27:
              _result = _context3.sent;
              component.setValueAt(cellLocation.row, pos.index, _result, true, false);

            case 29:
              _context3.next = 38;
              break;

            case 31:
              if (this.needCalc_Com(component, calcAll)) {
                _context3.next = 33;
                break;
              }

              return _context3.abrupt("return");

            case 33:
              _context3.next = 35;
              return this.calcFormulaValue(item, context);

            case 35:
              _result2 = _context3.sent;
              _context3.next = 38;
              return component.setValue(_result2, true, false);

            case 38:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3, this);
    }));

    function calcHeadItem(_x5, _x6, _x7, _x8) {
      return _calcHeadItem.apply(this, arguments);
    }

    return calcHeadItem;
  }(),
  calcListView: function () {
    var _calcListView = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee4(listView, context, item, calcAll) {
      var i, count;
      return regeneratorRuntime.wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              for (i = 0, count = listView.getRowCount(); i < count; i++) {
                this.impl_calcListViewRow(listView, this.newContext(this.form, i, -1), i, item, calcAll);
              }

            case 1:
            case "end":
              return _context4.stop();
          }
        }
      }, _callee4, this);
    }));

    function calcListView(_x9, _x10, _x11, _x12) {
      return _calcListView.apply(this, arguments);
    }

    return calcListView;
  }(),
  impl_calcListViewRow: function () {
    var _impl_calcListViewRow = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee5(listView, context, rowIndex, item, calcAll) {
      var items, i, exp, columnInfo, result;
      return regeneratorRuntime.wrap(function _callee5$(_context5) {
        while (1) {
          switch (_context5.prev = _context5.next) {
            case 0:
              items = item.items;

              if (items) {
                _context5.next = 3;
                break;
              }

              return _context5.abrupt("return");

            case 3:
              i = 0;

            case 4:
              if (!(exp = items[i])) {
                _context5.next = 17;
                break;
              }

              if (!(!exp.defaultValue && !exp.formulaValue || !exp.target)) {
                _context5.next = 7;
                break;
              }

              return _context5.abrupt("continue", 14);

            case 7:
              columnInfo = listView.getColumnInfo(exp.target);

              if (this.needCalc_listView(columnInfo, calcAll)) {
                _context5.next = 10;
                break;
              }

              return _context5.abrupt("continue", 14);

            case 10:
              _context5.next = 12;
              return this.calcFormulaValue(exp, context);

            case 12:
              result = _context5.sent;

              if (result) {
                listView.setValByKey(rowIndex, exp.target, result, true, false);
              }

            case 14:
              i++;
              _context5.next = 4;
              break;

            case 17:
            case "end":
              return _context5.stop();
          }
        }
      }, _callee5, this);
    }));

    function impl_calcListViewRow(_x13, _x14, _x15, _x16, _x17) {
      return _impl_calcListViewRow.apply(this, arguments);
    }

    return impl_calcListViewRow;
  }(),
  calcGrid: function () {
    var _calcGrid = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee6(grid, context, item, calcAll, commitValue) {
      var i, rowData, count;
      return regeneratorRuntime.wrap(function _callee6$(_context6) {
        while (1) {
          switch (_context6.prev = _context6.next) {
            case 0:
              i = 0, count = grid.getRowCount();

            case 1:
              if (!(i < count)) {
                _context6.next = 9;
                break;
              }

              if (grid.isRowDetail(i)) {
                _context6.next = 4;
                break;
              }

              return _context6.abrupt("continue", 6);

            case 4:
              _context6.next = 6;
              return this.impl_calcGridRow(grid, this.newContext(this.form, i, -1), i, item, calcAll, commitValue);

            case 6:
              i++;
              _context6.next = 1;
              break;

            case 9:
            case "end":
              return _context6.stop();
          }
        }
      }, _callee6, this);
    }));

    function calcGrid(_x18, _x19, _x20, _x21, _x22) {
      return _calcGrid.apply(this, arguments);
    }

    return calcGrid;
  }(),
  impl_calcGridRow: function () {
    var _impl_calcGridRow = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee7(grid, context, rowIndex, item, calcAll, commitValue) {
      var _item, pos, rowData, metaCell, i, c, length, result;

      return regeneratorRuntime.wrap(function _callee7$(_context7) {
        while (1) {
          switch (_context7.prev = _context7.next) {
            case 0:
              if (!(!item.items || rowIndex == -1)) {
                _context7.next = 2;
                break;
              }

              return _context7.abrupt("return");

            case 2:
              rowData = grid.getRowDataAt(rowIndex);
              i = 0;

            case 4:
              if (!((_item = item.items[i]) && (pos = _item.pos))) {
                _context7.next = 40;
                break;
              }

              if (!(!_item.defaultValue && !_item.formula || !_item.target)) {
                _context7.next = 7;
                break;
              }

              return _context7.abrupt("continue", 37);

            case 7:
              metaCell = grid.getMetaCellByKey(_item.target);
              commitValue = _YIUIBase.YIUI.GridUtil.isEmptyRow(rowData) ? false : commitValue;

              if (!pos.columnExpand) {
                _context7.next = 29;
                break;
              }

              c = 0, length = pos.indexes.length;

            case 11:
              if (!(c < length)) {
                _context7.next = 27;
                break;
              }

              if (this.needCalc_Cell(grid, rowIndex, pos.indexes[c], metaCell, calcAll)) {
                _context7.next = 14;
                break;
              }

              return _context7.abrupt("continue", 24);

            case 14:
              context.colIndex = pos.indexes[c];
              _context7.t0 = grid;
              _context7.t1 = rowIndex;
              _context7.t2 = pos.indexes[c];
              _context7.next = 20;
              return this.calcFormulaValue(_item, context);

            case 20:
              _context7.t3 = _context7.sent;
              _context7.t4 = commitValue;
              _context7.next = 24;
              return _context7.t0.setValueAt.call(_context7.t0, _context7.t1, _context7.t2, _context7.t3, _context7.t4, false);

            case 24:
              c++;
              _context7.next = 11;
              break;

            case 27:
              _context7.next = 37;
              break;

            case 29:
              if (this.needCalc_Cell(grid, rowIndex, pos.index, rowData[pos.index], metaCell, calcAll)) {
                _context7.next = 31;
                break;
              }

              return _context7.abrupt("continue", 37);

            case 31:
              context.rowIndex = rowIndex;
              _context7.next = 34;
              return this.calcFormulaValue(_item, context);

            case 34:
              result = _context7.sent;
              _context7.next = 37;
              return grid.setValueAt(rowIndex, pos.index, result, commitValue, false);

            case 37:
              i++;
              _context7.next = 4;
              break;

            case 40:
            case "end":
              return _context7.stop();
          }
        }
      }, _callee7, this);
    }));

    function impl_calcGridRow(_x23, _x24, _x25, _x26, _x27, _x28) {
      return _impl_calcGridRow.apply(this, arguments);
    }

    return impl_calcGridRow;
  }(),
  doCalcGridRow: function () {
    var _doCalcGridRow = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee8(grid, rowIndex, calcAll, commitValue) {
      var items, i, exp;
      return regeneratorRuntime.wrap(function _callee8$(_context8) {
        while (1) {
          switch (_context8.prev = _context8.next) {
            case 0:
              items = this.form.dependency.calcTree.items;
              i = 0;

            case 2:
              if (!(exp = items[i])) {
                _context8.next = 9;
                break;
              }

              if (!(exp.objectType == _YIUIBase.YIUI.ExprItem_Type.Set && exp.source === grid.key)) {
                _context8.next = 6;
                break;
              }

              _context8.next = 6;
              return this.impl_calcGridRow(grid, this.newContext(this.form, rowIndex, -1), rowIndex, exp, calcAll, commitValue);

            case 6:
              i++;
              _context8.next = 2;
              break;

            case 9:
            case "end":
              return _context8.stop();
          }
        }
      }, _callee8, this);
    }));

    function doCalcGridRow(_x29, _x30, _x31, _x32) {
      return _doCalcGridRow.apply(this, arguments);
    }

    return doCalcGridRow;
  }(),
  needCalc_Cell: function needCalc_Cell(grid, rowIndex, colIndex, cellData, metaCell, calcAll) {
    var ignoreKeys = this.form.getSysExpVals("IgnoreKeys");

    if (ignoreKeys) {
      return !metaCell.columnKey || _yesCommon.lodash.inArray(metaCell.key, ignoreKeys) == -1;
    }

    return calcAll ? true : !metaCell.columnKey;
  },
  needCalc_Com: function needCalc_Com(component, calcAll) {
    var ignoreKeys = this.form.getSysExpVals("IgnoreKeys");
    var hasDataBinding = component.isSubDetail ? component.hasDataBinding() || !component.bindingCellKey : component.hasDataBinding();

    if (ignoreKeys) {
      return !hasDataBinding || _yesCommon.lodash.inArray(component.key, ignoreKeys) == -1;
    }

    if (calcAll) {
      if (this.calcAlling && !component.isNull()) {
        return false;
      }
    } else {
      if (component.hasDataBinding() || component.bindingCellKey) {
        return false;
      }
    }

    return true;
  },
  needCalc_listView: function needCalc_listView(columnInfo, calcAll) {
    var ignoreKeys = this.form.getSysExpVals("IgnoreKeys");

    if (ignoreKeys) {
      return !columnInfo.columnKey || _yesCommon.lodash.inArray(columnInfo.key, ignoreKeys) == -1;
    }

    return calcAll ? true : !columnInfo.columnKey;
  },
  doAfterInsertRow: function () {
    var _doAfterInsertRow = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee9(component, rowIndex, emptyRow) {
      return regeneratorRuntime.wrap(function _callee9$(_context9) {
        while (1) {
          switch (_context9.prev = _context9.next) {
            case 0:
              if (!(component.type === _YIUIBase.YIUI.CONTROLTYPE.GRID)) {
                _context9.next = 5;
                break;
              }

              _context9.next = 3;
              return this.doCalcGridRow(component, rowIndex, emptyRow, false);

            case 3:
              _context9.next = 7;
              break;

            case 5:
              _context9.next = 7;
              return this.calcListViewRow(component, rowIndex, true);

            case 7:
            case "end":
              return _context9.stop();
          }
        }
      }, _callee9, this);
    }));

    function doAfterInsertRow(_x33, _x34, _x35) {
      return _doAfterInsertRow.apply(this, arguments);
    }

    return doAfterInsertRow;
  }(),
  calcListViewRow: function calcListViewRow(listView, rowIndex, calcAll) {
    var items = this.form.dependency.calcTree.items;

    for (var i = 0, exp; exp = items[i]; i++) {
      if (exp.objectType === _YIUIBase.YIUI.ExprItem_Type.Set && exp.source === listView.key) {
        this.impl_calcListViewRow(listView, this.newContext(this.form, rowIndex, -1), rowIndex, exp, calcAll);
      }
    }
  },
  calcExprItemObject: function () {
    var _calcExprItemObject = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee10(com, item, ctx, calcAll, commitValue) {
      return regeneratorRuntime.wrap(function _callee10$(_context10) {
        while (1) {
          switch (_context10.prev = _context10.next) {
            case 0:
              _context10.t0 = item.objectType;
              _context10.next = _context10.t0 === _YIUIBase.YIUI.ExprItem_Type.Item ? 3 : _context10.t0 === _YIUIBase.YIUI.ExprItem_Type.Set ? 6 : 15;
              break;

            case 3:
              _context10.next = 5;
              return this.calcHeadItem(com, item, ctx, calcAll);

            case 5:
              return _context10.abrupt("break", 15);

            case 6:
              _context10.t1 = com.type;
              _context10.next = _context10.t1 === _YIUIBase.YIUI.CONTROLTYPE.GRID ? 9 : _context10.t1 === _YIUIBase.YIUI.CONTROLTYPE.LISTVIEW ? 12 : 15;
              break;

            case 9:
              _context10.next = 11;
              return this.calcGrid(com, ctx, this.initTree(item), calcAll, commitValue);

            case 11:
              return _context10.abrupt("break", 15);

            case 12:
              _context10.next = 14;
              return this.calcListView(com, ctx, this.initTree(item), calcAll);

            case 14:
              return _context10.abrupt("break", 15);

            case 15:
            case "end":
              return _context10.stop();
          }
        }
      }, _callee10, this);
    }));

    function calcExprItemObject(_x36, _x37, _x38, _x39, _x40) {
      return _calcExprItemObject.apply(this, arguments);
    }

    return calcExprItemObject;
  }(),
  valueChanged: function () {
    var _valueChanged = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee11(comp) {
      var items, context, item, com, i;
      return regeneratorRuntime.wrap(function _callee11$(_context11) {
        while (1) {
          switch (_context11.prev = _context11.next) {
            case 0:
              if (!this.isInAllCalculating()) {
                _context11.next = 2;
                break;
              }

              return _context11.abrupt("return");

            case 2:
              items = this.form.dependency.calcTree.affectItems[comp.key];

              if (items) {
                _context11.next = 5;
                break;
              }

              return _context11.abrupt("return");

            case 5:
              context = this.newContext(this.form, -1, -1);
              i = 0;

            case 7:
              if (!(item = items[i])) {
                _context11.next = 16;
                break;
              }

              com = this.form.getComponent(item.source);

              if (com) {
                _context11.next = 11;
                break;
              }

              return _context11.abrupt("continue", 13);

            case 11:
              _context11.next = 13;
              return this.calcExprItemObject(com, item, context, true, true);

            case 13:
              i++;
              _context11.next = 7;
              break;

            case 16:
            case "end":
              return _context11.stop();
          }
        }
      }, _callee11, this);
    }));

    function valueChanged(_x41) {
      return _valueChanged.apply(this, arguments);
    }

    return valueChanged;
  }(),
  reCalcComponent: function () {
    var _reCalcComponent = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee12(component) {
      var items, i, exp;
      return regeneratorRuntime.wrap(function _callee12$(_context12) {
        while (1) {
          switch (_context12.prev = _context12.next) {
            case 0:
              items = this.form.dependency.calcTree.items;
              i = 0;

            case 2:
              if (!(exp = items[i])) {
                _context12.next = 19;
                break;
              }

              if (!(exp.objectType != _YIUIBase.YIUI.ExprItem_Type.Set)) {
                _context12.next = 5;
                break;
              }

              return _context12.abrupt("continue", 16);

            case 5:
              if (!(exp.source !== component.key)) {
                _context12.next = 7;
                break;
              }

              return _context12.abrupt("continue", 16);

            case 7:
              _context12.t0 = component.type;
              _context12.next = _context12.t0 === _YIUIBase.YIUI.CONTROLTYPE.GRID ? 10 : _context12.t0 === _YIUIBase.YIUI.CONTROLTYPE.LISTVIEW ? 13 : 16;
              break;

            case 10:
              _context12.next = 12;
              return this.calcGrid(component, this.newContext(this.form, -1, -1), this.initTree(exp), false, false);

            case 12:
              return _context12.abrupt("break", 16);

            case 13:
              _context12.next = 15;
              return this.calcListView(component, this.newContext(this.form, -1, -1), this.initTree(exp), false);

            case 15:
              return _context12.abrupt("break", 16);

            case 16:
              i++;
              _context12.next = 2;
              break;

            case 19:
            case "end":
              return _context12.stop();
          }
        }
      }, _callee12, this);
    }));

    function reCalcComponent(_x42) {
      return _reCalcComponent.apply(this, arguments);
    }

    return reCalcComponent;
  }(),
  cellValueChanged: function () {
    var _cellValueChanged = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee13(grid, rowIndex, colIndex) {
      var affectItems, rowData, cellKey, items, i, exp, component, calcInGrid, calcParGrid;
      return regeneratorRuntime.wrap(function _callee13$(_context13) {
        while (1) {
          switch (_context13.prev = _context13.next) {
            case 0:
              affectItems = this.form.dependency.calcTree.affectItems;
              rowData = grid.getRowDataAt(rowIndex);
              cellKey = rowData.cellKeys[colIndex];
              items = affectItems[cellKey]; // for (var i = 0, size = affectItems.length; i < size; i++) {
              //     if (affectItems[i].key === cellKey) {
              //         items = affectItems[i];
              //         break;
              //     }
              // }

              if (!items) {
                _context13.next = 35;
                break;
              }

              i = 0;

            case 6:
              if (!(exp = items[i])) {
                _context13.next = 35;
                break;
              }

              component = this.form.getComponent(exp.source);

              if (component) {
                _context13.next = 10;
                break;
              }

              return _context13.abrupt("continue", 32);

            case 10:
              _context13.t0 = exp.objectType;
              _context13.next = _context13.t0 === _YIUIBase.YIUI.ExprItem_Type.Item ? 13 : _context13.t0 === _YIUIBase.YIUI.ExprItem_Type.Set ? 16 : 31;
              break;

            case 13:
              _context13.next = 15;
              return this.calcHeadItem(component, exp, this.newContext(this.form, -1, -1), true);

            case 15:
              return _context13.abrupt("break", 32);

            case 16:
              calcInGrid = component.key === grid.key;
              calcParGrid = _YIUIBase.YIUI.SubDetailUtil.isSubDetail(this.form, grid, component.key);

              if (!calcInGrid) {
                _context13.next = 23;
                break;
              }

              _context13.next = 21;
              return this.impl_calcGridRow(component, this.newContext(this.form, rowIndex, -1), rowIndex, exp, true, true);

            case 21:
              _context13.next = 30;
              break;

            case 23:
              if (!calcParGrid) {
                _context13.next = 28;
                break;
              }

              _context13.next = 26;
              return this.impl_calcGridRow(component, this.newContext(this.form, -1, -1), component.getFocusRowIndex(), exp, true, true);

            case 26:
              _context13.next = 30;
              break;

            case 28:
              _context13.next = 30;
              return this.calcGrid(component, this.newContext(this.form, -1, -1), this.initTree(exp), true, true);

            case 30:
              return _context13.abrupt("break", 32);

            case 31:
              return _context13.abrupt("break", 32);

            case 32:
              i++;
              _context13.next = 6;
              break;

            case 35:
            case "end":
              return _context13.stop();
          }
        }
      }, _callee13, this);
    }));

    function cellValueChanged(_x43, _x44, _x45) {
      return _cellValueChanged.apply(this, arguments);
    }

    return cellValueChanged;
  }(),
  doAfterDeleteRow: function () {
    var _doAfterDeleteRow = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee14(grid) {
      var metaRow, items, affectItems, i, metaCell, itms, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, k, exp, component;

      return regeneratorRuntime.wrap(function _callee14$(_context14) {
        while (1) {
          switch (_context14.prev = _context14.next) {
            case 0:
              metaRow = grid.getDetailRow();
              items = [], affectItems = this.form.dependency.calcTree.affectItems;
              i = 0;

            case 3:
              if (!(metaCell = metaRow.cells[i])) {
                _context14.next = 28;
                break;
              }

              itms = affectItems[metaCell.key]; // for (var j = 0, length = affectItems.length; j < length; j++) {

              if (!itms) {
                _context14.next = 25;
                break;
              }

              _iteratorNormalCompletion = true;
              _didIteratorError = false;
              _iteratorError = undefined;
              _context14.prev = 9;

              for (_iterator = itms[Symbol.iterator](); !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                k = _step.value;

                if (k.source == grid.key && k.objectType === _YIUIBase.YIUI.ExprItem_Type.Set) {
                  items.push(k);
                } // if (affectItems[j].key === metaCell.key) {
                //     items.push(affectItems[j].expItems);
                // }

              }

              _context14.next = 17;
              break;

            case 13:
              _context14.prev = 13;
              _context14.t0 = _context14["catch"](9);
              _didIteratorError = true;
              _iteratorError = _context14.t0;

            case 17:
              _context14.prev = 17;
              _context14.prev = 18;

              if (!_iteratorNormalCompletion && _iterator["return"] != null) {
                _iterator["return"]();
              }

            case 20:
              _context14.prev = 20;

              if (!_didIteratorError) {
                _context14.next = 23;
                break;
              }

              throw _iteratorError;

            case 23:
              return _context14.finish(20);

            case 24:
              return _context14.finish(17);

            case 25:
              i++;
              _context14.next = 3;
              break;

            case 28:
              items.sort(function (item1, item2) {
                return parseInt(item1.order) - parseInt(item2.order);
              });
              i = 0;

            case 30:
              if (!(exp = items[i])) {
                _context14.next = 47;
                break;
              }

              component = this.form.getComponent(exp.source);

              if (component) {
                _context14.next = 34;
                break;
              }

              return _context14.abrupt("continue", 44);

            case 34:
              _context14.t1 = exp.objectType;
              _context14.next = _context14.t1 === _YIUIBase.YIUI.ExprItem_Type.Item ? 37 : _context14.t1 === _YIUIBase.YIUI.ExprItem_Type.Set ? 40 : 44;
              break;

            case 37:
              _context14.next = 39;
              return this.calcHeadItem(component, exp, this.newContext(this.form, -1, -1), true);

            case 39:
              return _context14.abrupt("break", 44);

            case 40:
              if (!_YIUIBase.YIUI.SubDetailUtil.isSubDetail(this.form, grid, component.key)) {
                _context14.next = 43;
                break;
              }

              _context14.next = 43;
              return this.impl_calcGridRow(component, this.newContext(this.form, -1, -1), component.getFocusRowIndex(), exp, true, true);

            case 43:
              return _context14.abrupt("break", 44);

            case 44:
              i++;
              _context14.next = 30;
              break;

            case 47:
            case "end":
              return _context14.stop();
          }
        }
      }, _callee14, this, [[9, 13, 17, 25], [18,, 20, 24]]);
    }));

    function doAfterDeleteRow(_x46) {
      return _doAfterDeleteRow.apply(this, arguments);
    }

    return doAfterDeleteRow;
  }(),
  // 表格汇总没加--一般不会在子明细添加汇总
  calcSubDetail: function calcSubDetail(grid, calcAll) {
    var items = this.form.dependency.calcTree.items;

    for (var i = 0, exp, component; exp = items[i]; i++) {
      component = this.form.getComponent(exp.source);
      if (!component || !_YIUIBase.YIUI.SubDetailUtil.isSubDetail(this.form, component, grid.key)) continue;

      switch (exp.objectType) {
        case _YIUIBase.YIUI.ExprItem_Type.Item:
          this.calcHeadItem(component, exp, this.newContext(this.form, -1, -1), calcAll);
          break;

        case _YIUIBase.YIUI.ExprItem_Type.Set:
          switch (component.type) {
            case _YIUIBase.YIUI.CONTROLTYPE.GRID:
              this.calcGrid(component, this.newContext(this.form, -1, -1), this.initTree(exp), calcAll, false);
              break;

            case _YIUIBase.YIUI.CONTROLTYPE.LISTVIEW:
              this.calcListView(component, this.newContext(this.form, -1, -1), this.initTree(exp), calcAll);
              break;
          }

          break;
      }
    }
  }
}); // })();


exports["default"] = _default;