"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _YIUIBase = require("../YIUI-base");

require("../YIUI-common");

require("../YIUI-parser");

require("../YIUI-svr");

var _yesCommon = require("yes-common");

require("../uiprocess");

require("../abstractuiprocess");

require("../yes-ui");

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var _default = _YIUIBase.YIUI.UIDependencyProcess = function () {
  // 单例对象
  var Return = {
    valueChanged: function valueChanged(form, component) {
      var relations = form.dependency.relationTree;
      var targetFields, targetField, targetComp, cellLocation, grid, columnInfo;

      for (var field in relations) {
        if (field !== component.key) continue;
        var targetFields = relations[field];

        for (var i = 0, len = targetFields.length; i < len; i++) {
          targetField = targetFields[i];
          targetComp = form.getComponent(targetField);

          if (targetComp != null) {
            targetComp.dependedValueChange(targetField, field, null);
            continue;
          }

          cellLocation = form.getCellLocation(targetField);

          if (cellLocation != null) {
            grid = form.getComponent(cellLocation.key);
            grid.dependedValueChange(targetField, field, null);
          }
        }
      }
    },
    cellValueChanged: function () {
      var _cellValueChanged = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee(form, grid, rowIndex, colIndex, cellKey) {
        var relations, targetFields, field, i, len, loc, columns, j;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                relations = form.dependency.relationTree;
                _context.t0 = regeneratorRuntime.keys(relations);

              case 2:
                if ((_context.t1 = _context.t0()).done) {
                  _context.next = 28;
                  break;
                }

                field = _context.t1.value;

                if (!(field !== cellKey)) {
                  _context.next = 6;
                  break;
                }

                return _context.abrupt("continue", 2);

              case 6:
                targetFields = relations[field];
                i = 0, len = targetFields.length;

              case 8:
                if (!(i < len)) {
                  _context.next = 26;
                  break;
                }

                loc = form.getCellLocation(targetFields[i]);

                if (!loc.expand) {
                  _context.next = 21;
                  break;
                }

                columns = loc.columns;
                j = 0;

              case 13:
                if (!(j < columns.length)) {
                  _context.next = 19;
                  break;
                }

                _context.next = 16;
                return grid.setValueAt(rowIndex, columns[j], null, true, true);

              case 16:
                j++;
                _context.next = 13;
                break;

              case 19:
                _context.next = 23;
                break;

              case 21:
                _context.next = 23;
                return grid.setValueAt(rowIndex, loc.column, null, true, true);

              case 23:
                i++;
                _context.next = 8;
                break;

              case 26:
                _context.next = 2;
                break;

              case 28:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      function cellValueChanged(_x, _x2, _x3, _x4, _x5) {
        return _cellValueChanged.apply(this, arguments);
      }

      return cellValueChanged;
    }(),
    doAfterInsertRow: function doAfterInsertRow(grid, rowIndex) {// var gridRow = grid.getRowDataAt(rowIndex), metaRow = grid.getMetaObj().rows[gridRow.metaRowIndex];
      // for (var i = 0, len = metaRow.cells.length; i < len; i++) {
      //     var metaCell = metaRow.cells[i];
      //     if (metaCell.cellType == YIUI.CONTROLTYPE.DYNAMIC) {
      //         //TODO 刷新动态单元格
      //     }
      // }
    }
  };
  return Return;
}();

exports["default"] = _default;