"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _YIUIBase = require("../YIUI-base");

require("../YIUI-common");

require("../YIUI-parser");

var _YIUISvr = _interopRequireDefault(require("../YIUI-svr"));

var _yesCommon = require("yes-common");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var _default = _YIUIBase.YIUI.DocService = function () {
  // var cache = new YIUI.DocCache();
  // var reqMap = {};
  var Return = {
    /**
     * 创建一个doc，头表新增一行。
     */
    newDocument: function () {
      var _newDocument = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee(formKey) {
        var params;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                // if(!reqMap[formKey]){
                //     reqMap[formKey] = cache.get(formKey)
                //                        .then(function(doc){
                //                                if(doc){
                //                                    return doc;
                //                                }else{
                //
                //                                }
                //                        },function(error){
                //                            console.log('error ......'+error);
                //                        }).then(function(doc){
                //                        	return YIUI.DataUtil.fromJSONDoc(doc);
                //                        }).always(function(){
                //                            setTimeout(function(){
                //                                delete reqMap[formKey];
                //                            },100);
                //                        });
                // }
                //
                // return reqMap[formKey];
                params = {
                  cmd: "NewDocument",
                  service: "DealWithDocument",
                  formKey: formKey
                };
                _context.next = 3;
                return _YIUISvr["default"].Request.getData(params, null, false);

              case 3:
                return _context.abrupt("return", _context.sent);

              case 4:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      function newDocument(_x) {
        return _newDocument.apply(this, arguments);
      }

      return newDocument;
    }(),
    // see remoteService.loadbyform
    loadFormData: function () {
      var _loadFormData = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee2(form, oid, filterMap, condParas) {
        var parameters, params, _loadInfo, templateKey;

        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                if (form) {
                  _context2.next = 2;
                  break;
                }

                throw new Error(_YIUIBase.YIUI.I18N.docserviceproxy.notNull);

              case 2:
                _context2.next = 4;
                return form.refreshParas();

              case 4:
                parameters = form.getParas();
                params = {
                  cmd: "",
                  service: "LoadFormData",
                  oid: oid,
                  formKey: form.getFormKey()
                };

                if (parameters) {
                  params.parameters = parameters.toJSON();
                }

                if (filterMap) {
                  filterMap.OID = oid;
                  params.filterMap = _yesCommon.lodash.toJSON(filterMap);
                }

                if (condParas) {
                  params.condition = _yesCommon.lodash.toJSON(condParas);
                }

                _loadInfo = form.getSysExpVals(_YIUIBase.YIUI.BPMKeys.LOAD_WORKITEM_INFO);

                if (_loadInfo != undefined) {
                  params.loadWorkItemInfo = _loadInfo;
                }

                templateKey = form.getTemplateKey();

                if (templateKey) {
                  params.templateKey = templateKey;
                }

                _context2.next = 15;
                return _YIUISvr["default"].Request.getData(params, null, false);

              case 15:
                return _context2.abrupt("return", _context2.sent);

              case 16:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2);
      }));

      function loadFormData(_x2, _x3, _x4, _x5) {
        return _loadFormData.apply(this, arguments);
      }

      return loadFormData;
    }(),
    // see remoteService.deletebyform
    deleteFormData: function deleteFormData(formKey, oid) {
      var params = {
        cmd: "DeleteFormData",
        service: "DeleteData",
        formKey: formKey,
        oid: oid
      }; //return Svr.Request.getData(params);

      return _YIUISvr["default"].Request.getSyncData(_YIUISvr["default"].SvrMgr.ServletURL, params);
    },
    saveFormData: function saveFormData(form) {
      form.refreshParas();
      var parameters = form.getParas();
      var formDoc = form.getDocument();

      var docJson = _YIUIBase.YIUI.DataUtil.toJSONDoc(formDoc);

      var params = {
        cmd: "",
        service: "SaveFormData",
        formKey: formKey,
        document: _yesCommon.lodash.toJSON(docJson)
      };

      if (parameters) {
        params.parameters = parameters.toJSON();
      } //return Svr.Request.getData(params);


      return _YIUISvr["default"].Request.getSyncData(_YIUISvr["default"].SvrMgr.ServletURL, params);
    }
  };
  return Return;
}();

exports["default"] = _default;