/*
 * @Author: gmf
 * @Date:   2016-03-18 10:53:01
 * @Last Modified by:   gmf
 * @Last Modified time: 2016-06-23 09:48:39
 */

import BaseControl from './control';
import { YIUI } from '../../YIUI-base';
import '../../YIUI-common';
import '../../YIUI-svr';
import '../../YIUI-parser';
import { regControlType } from './controlUtil';
const TextArea = YIUI.extend(BaseControl, {
    handler: YIUI.TextAreaHandler,
    /**
     * Number。
     * 允许输入的最大长度。
     */
    maxLength: Number.MAX_VALUE,
    getText: function() {
        return this.value;
    },
});
YIUI.reg('textarea', TextArea);
regControlType(YIUI.CONTROLTYPE.TEXTAREA,'textarea');
export default TextArea;
