/*
 * @Author: gmf
 * @Date:   2016-03-17 15:14:27
 * @Last Modified by:   gmf
 * @Last Modified time: 2016-12-29 15:43:30
 */

import BaseControl from './control';
import { YIUI } from '../../YIUI-base';
import Svr from '../../YIUI-svr';
import '../../YIUI-common';
import '../../YIUI-parser';
import { regControlType } from './controlUtil';
const TextEditor = YIUI.extend(BaseControl, {
    init(options) {
        if (this.caption) {
            this.text = this.caption;
        }
        this.base(options);
        const icon = this.getMetaObj().icon;
        if (icon) {
            this.getMetaObj().icon = `${Svr.SvrMgr.AttachURL}/../Resource/${icon}`;
        }
        const preIcon = this.getMetaObj().preIcon;
        if (preIcon) {
            this.getMetaObj().preIcon = `${Svr.SvrMgr.AttachURL}/../Resource/${preIcon}`;
        }
    },
    // handler: YIUI.TextEditorHandler,
    getText() {
        return this.getValue();
    },
});
YIUI.reg('texteditor', TextEditor);
YIUI.reg('passwordeditor', TextEditor);
// 掩码控件也以文字输入框实现
YIUI.reg('maskeditor', TextEditor);
regControlType(YIUI.CONTROLTYPE.TEXTEDITOR, 'texteditor');
regControlType(YIUI.CONTROLTYPE.MASKEDITOR, 'maskeditor');
regControlType(YIUI.CONTROLTYPE.PASSWORDEDITOR, 'passwordeditor');
export default TextEditor;
