"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _control = _interopRequireDefault(require("./control"));

var _YIUIBase = require("../../YIUI-base");

require("../../YIUI-common");

require("../../YIUI-svr");

require("../../YIUI-parser");

var _controlUtil = require("./controlUtil");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/*
 * @Author: gmf
 * @Date:   2016-06-23 09:45:37
 * @Last Modified by:   gmf
 * @Last Modified time: 2016-06-23 11:03:14
 */
var Checkbox = _YIUIBase.YIUI.extend(_control["default"], {
  // handler: YIUI.CheckBoxHandler,
  setInnerValue: function setInnerValue(v) {
    var newV = _YIUIBase.YIUI.TypeConvertor.toBoolean(v);

    var state = this.state.set('value', newV);
    this.changeState(state);
  }
});

_YIUIBase.YIUI.reg('checkbox', Checkbox);

_YIUIBase.YIUI.reg('switch', Checkbox);

(0, _controlUtil.regControlType)(_YIUIBase.YIUI.CONTROLTYPE.CHECKBOX, 'checkbox');
(0, _controlUtil.regControlType)(_YIUIBase.YIUI.CONTROLTYPE.SWITCH, 'switch');
var _default = Checkbox;
exports["default"] = _default;