"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _control = _interopRequireDefault(require("./control"));

var _YIUIBase = require("../../YIUI-base");

var _YIUISvr = _interopRequireDefault(require("../../YIUI-svr"));

require("../../YIUI-common");

require("../../YIUI-parser");

var _controlUtil = require("./controlUtil");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/*
 * @Author: gmf
 * @Date:   2016-03-17 15:14:27
 * @Last Modified by:   gmf
 * @Last Modified time: 2016-12-29 15:43:30
 */
var TextEditor = _YIUIBase.YIUI.extend(_control["default"], {
  init: function init(options) {
    if (this.caption) {
      this.text = this.caption;
    }

    this.base(options);
    var icon = this.getMetaObj().icon;

    if (icon) {
      this.getMetaObj().icon = "".concat(_YIUISvr["default"].SvrMgr.AttachURL, "/../Resource/").concat(icon);
    }

    var preIcon = this.getMetaObj().preIcon;

    if (preIcon) {
      this.getMetaObj().preIcon = "".concat(_YIUISvr["default"].SvrMgr.AttachURL, "/../Resource/").concat(preIcon);
    }
  },
  // handler: YIUI.TextEditorHandler,
  getText: function getText() {
    return this.getValue();
  }
});

_YIUIBase.YIUI.reg('texteditor', TextEditor);

_YIUIBase.YIUI.reg('passwordeditor', TextEditor); // 掩码控件也以文字输入框实现


_YIUIBase.YIUI.reg('maskeditor', TextEditor);

(0, _controlUtil.regControlType)(_YIUIBase.YIUI.CONTROLTYPE.TEXTEDITOR, 'texteditor');
(0, _controlUtil.regControlType)(_YIUIBase.YIUI.CONTROLTYPE.MASKEDITOR, 'maskeditor');
(0, _controlUtil.regControlType)(_YIUIBase.YIUI.CONTROLTYPE.PASSWORDEDITOR, 'passwordeditor');
var _default = TextEditor;
exports["default"] = _default;