"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.injectDispatcher = injectDispatcher;
exports["default"] = _default;
exports.ready = ready;
var dispatcher = {
  dispatch: function dispatch() {},
  register: function register() {}
};
var inited = null;
var promise = new Promise(function (resolve) {
  inited = function inited() {
    resolve();
  };
});

function injectDispatcher(disp) {
  dispatcher = disp;
  inited();
}

function _default() {
  return dispatcher;
}

function ready(callback) {
  promise.then(callback);
}