"use strict";

var _YIUIBase = require("./YIUI-base");

require("./YIUI-common");

require("./YIUI-parser");

require("./YIUI-svr");

_YIUIBase.YIUI.FormStack = function () {
  var Return = {
    addForm: function addForm(form) {
      if (typeof this.formList == "undefined") {
        this.formList = new Array();
      }

      this.formList.push(form);
    },
    getForm: function getForm(formID) {
      for (var i = 0; i < this.formList.length; i++) {
        if (formID == this.formList[i].formID) {
          return this.formList[i];
        }
      }

      return null;
    },
    removeForm: function removeForm(formID) {
      for (var i = 0; i < this.formList.length; i++) {
        if (formID == this.formList[i].formID) {
          this.formList[i].destroy();
          this.formList.splice(i, 1);
        }
      }
    },
    removeAll: function removeAll() {
      if (!this.formList) return;

      for (var i = 0; i < this.formList.length; i++) {
        this.formList[i].destroy();
      }

      this.formList = [];
    }
  };
  return Return;
}();