"use strict";

var _YIUIBase = require("../YIUI-base");

require("../YIUI-common");

require("../YIUI-parser");

var _YIUISvr = _interopRequireDefault(require("../YIUI-svr"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

_YIUIBase.YIUI.RightsService = function () {
  var _default = {
    service: "SessionRights",
    cmd: "LoadFormRights"
  };
  var Return = {
    /**
     * 表单字段，操作权限
     */
    loadFormRights: function () {
      var _loadFormRights = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee(formKey, params) {
        var newParams;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                newParams = Object.assign({}, _default, params);
                _context.next = 3;
                return _YIUISvr["default"].Request.getData(newParams);

              case 3:
                return _context.abrupt("return", _context.sent);

              case 4:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      function loadFormRights(_x, _x2) {
        return _loadFormRights.apply(this, arguments);
      }

      return loadFormRights;
    }()
  };
  return Return;
}();