"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _YIUIBase = require("../YIUI-base");

require("../YIUI-common");

require("../YIUI-parser");

require("../YIUI-svr");

var _default = _YIUIBase.YIUI.TotalRowCountUtil = function () {
  var Return = {
    getKey: function getKey(tableKey) {
      return tableKey + "_RowCount";
    },
    getRowCount: function getRowCount(doc, tableKey) {
      return _YIUIBase.YIUI.TypeConvertor.toInt(doc.getExpData(this.getKey(tableKey)));
    },
    setRowCount: function setRowCount(doc, tableKey, rowCount) {
      doc.putExpData(this.getKey(tableKey), rowCount);
      doc.expDataType[this.getKey(tableKey)] = _YIUIBase.YIUI.ExpandDataType.LONG;
    }
  };
  return Return;
}();

exports["default"] = _default;