/*
 * @Author: gmf
 * @Date:   2016-06-20 16:23:40
 * @Last Modified by:   gmf
 * @Last Modified time: 2016-12-29 17:04:21
 */

import BaseControl from './control';
import { regControlType } from './controlUtil';
import { YIUI } from '../../YIUI-base';
import '../../YIUI-common';
import Svr from '../../YIUI-svr';
import '../../YIUI-parser';
const Image = YIUI.extend(BaseControl, {
    calculateDisplayValue: async function (v) {
        const form = YIUI.FormStack.getForm(this.ofFormID);
        const formKey = form.formKey;
        const sourceType = this.getMetaObj().sourceType;
        if (v) {
            if (sourceType === YIUI.IMAGE_SOURCETYPE.DATA) {
                let text = `${Svr.SvrMgr.AttachURL}?path=${encodeURIComponent(v)}&formKey=${formKey}&service=DownloadImage&mode=2`;
                return text;
            } else {
                return `${Svr.SvrMgr.AttachURL}/../Resource/${this.getMetaObj().image}`;
            }
        }
        return '';
    },
});
YIUI.reg('image', Image);
regControlType(YIUI.CONTROLTYPE.IMAGE, 'image');
export default Image;
