export default class YESException extends Error {
    constructor(errorCode, args, msg) {
        let realMsg = msg;
        try {
            let json = JSON.parse(msg);
            realMsg = json.message;
        } catch (ex) {
            console.log(ex);
        }
        super(realMsg);
        this.code = errorCode;
        this.args = args;
    }
}
